<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑活动报名' : '添加活动报名'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="活动ID" name="activityId">
        <a-input
          allow-clear
          placeholder="请输入活动ID"
          v-model:value="form.activityId"
        />
      </a-form-item>
      <a-form-item label="用户ID" name="userId">
        <a-input
          allow-clear
          placeholder="请输入用户ID"
          v-model:value="form.userId"
        />
      </a-form-item>
      <a-form-item label="报名表单数据" name="formData">
        <a-textarea
          allow-clear
          :rows="4"
          placeholder="请输入报名表单填写数据(JSON格式)"
          v-model:value="form.formData"
        />
      </a-form-item>
      <a-form-item label="支付金额" name="payAmount">
        <a-input-number
          :min="0"
          :precision="2"
          class="ele-fluid"
          placeholder="请输入支付金额"
          v-model:value="form.payAmount"
        />
      </a-form-item>
      <a-form-item label="支付状态" name="payStatus">
        <a-radio-group v-model:value="form.payStatus">
          <a-radio :value="0">未支付</a-radio>
          <a-radio :value="1">已支付</a-radio>
        </a-radio-group>
      </a-form-item>
      <a-form-item label="支付时间" name="payTime">
        <a-date-picker
          show-time
          format="YYYY-MM-DD HH:mm:ss"
          class="ele-fluid"
          placeholder="请选择支付时间"
          v-model:value="payTimeValue"
          @change="onPayTimeChange"
        />
      </a-form-item>
      <a-form-item label="第三方交易号" name="transactionId">
        <a-input
          allow-clear
          placeholder="请输入第三方交易号"
          v-model:value="form.transactionId"
        />
      </a-form-item>
      <a-form-item label="状态" name="status">
        <a-radio-group v-model:value="form.status">
          <a-radio :value="0">已报名</a-radio>
          <a-radio :value="1">已取消</a-radio>
        </a-radio-group>
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addShopActivitySignup, updateShopActivitySignup } from '@/api/shop/shopActivitySignup';
  import { ShopActivitySignup } from '@/api/shop/shopActivitySignup/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';
  import dayjs from 'dayjs';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: ShopActivitySignup | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 支付时间
  const payTimeValue = ref<dayjs.Dayjs | null>(null);

  // 用户信息
  const form = reactive<ShopActivitySignup>({
    signupId: undefined,
    activityId: undefined,
    userId: undefined,
    formData: undefined,
    payAmount: undefined,
    payStatus: 0,
    payTime: undefined,
    transactionId: undefined,
    status: 0,
    deleted: undefined,
    tenantId: undefined,
    createTime: undefined,
    updateTime: undefined,
    shopActivitySignupId: undefined,
    shopActivitySignupName: ''
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    shopActivitySignupName: [
      {
        required: true,
        type: 'string',
        message: '请填写活动报名表名称',
        trigger: 'blur'
      }
    ]
  });

  const onPayTimeChange = (_: any, dateString: string) => {
    form.payTime = dateString;
  };

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateShopActivitySignup : addShopActivitySignup;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if(props.data.image){
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            })
          }
          // 解析支付时间
          if (props.data.payTime) {
            payTimeValue.value = dayjs(props.data.payTime);
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
